=== debian/changelog ===
intel-ipsec-mb (1.5-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 13:10:33 +0200

intel-ipsec-mb (1.5-1) unstable; urgency=medium

  * Sync to latest 1.5 release

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 8 Nov 2023 13:36:38 +0000
