=== debian/control ===
Source: intel-ipsec-mb
Rules-Requires-Root: no
Section: utils
Priority: optional
Uploaders: Kamal Mostafa <kamal@whence.com>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Colin Ian King <colin.i.king@gmail.com>
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               nasm
Standards-Version: 4.6.2
Homepage: https://github.com/intel/intel-ipsec-mb

Package: libipsec-mb1
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.

Package: libipsec-mb-dev
Section: libdevel
Architecture: linux-amd64
Depends: ${misc:Depends}, libipsec-mb1 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
 Libipsec-mb is highly-optimized software implementations of
 the core cryptographic processing for IPsec, which provides
 industry-leading performance on a range of Intel(R) Processors.
 This package contains the development libraries and headers.
